﻿using System;
using System.Text;
using System.Management.Automation;
using System.Management.Automation.Runspaces;
using System.Security;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Collections;

class Program
{
    static void Main()
    {
        //管理者アカウントを指定
        string strAccount = "DOMAIN\\Admin";
        //パスワードを指定
        string strPassword = "PASSWORD";
        //Hyper-Vサーバーを指定
        string strServer = "HvHost01";
        //実行するコマンドを指定
        string strRunCmd = "Get-VM | Out-String";
        string strRunCmd2 = "Get-VM"; //or C:\MyPowerShell.ps1
        //Invoke-Commandに埋め込み
        string strCmd = ""; //or C:\MyPowerShell.ps1
        //strCmd += "Set-Item WSMan:\\LocalHost\\Client\\TrustedHosts -Value * -Force;";
        strCmd += "$AdminPassword = ConvertTo-SecureString '" + strPassword + "' -AsPlainText -Force;";
        strCmd += "$ObjectTypeName = 'System.Management.Automation.PSCredential';";
        strCmd += "$Cred = New-Object -TypeName $ObjectTypeName -ArgumentList '" + strAccount + "', $AdminPassword;";
        strCmd += "Invoke-Command -ComputerName " + strServer + " -ScriptBlock {" + strRunCmd + "} -Cred $Cred;";
        //非同期のコマンド指定
        string[] strAsyncCmds = {"Export-VM –Name VM01 –Path D:\\Exp", "Start-VM VM02", "Get-VM", "Start-VM VM03"};
       
        //コマンドを実行
        AsyncPowershell(strServer, strAccount, strPassword, strAsyncCmds);
        //RunPowerShell(strCmd);
        //RemotePowershell(strServer, strAccount, strPassword, strRunCmd);
        //RemotePipeline(strServer, strAccount, strPassword, strRunCmd2);
    }

    static void AsyncPowershell(string strServer, string strAccount, string strPassword, string[] strCmds)
    {
        //パスワードを暗号化
        SecureString objSecureString = new SecureString();
        foreach (char c in strPassword.ToCharArray()) { objSecureString.AppendChar(c); }
        PSCredential objPSCredential = new PSCredential(strAccount, objSecureString);

        //WinRMを利用してリモートでPowerShellを実行
        Uri objUri = new Uri("http://" + strServer + ":5985/wsman");
        WSManConnectionInfo objWSManConnectionInfo = new WSManConnectionInfo(objUri, "http://schemas.microsoft.com/powershell/Microsoft.PowerShell", objPSCredential);

        int intRunspace = strCmds.Length;
        using (RunspacePool objRunspacePool = RunspaceFactory.CreateRunspacePool(1, intRunspace, objWSManConnectionInfo))
        {
            //objRunspacePool.ApartmentState = Threading.ApartmentState.STA
            //objRunspacePool.ThreadOptions = PSThreadOptions.UseNewThread
            objRunspacePool.Open();

            ArrayList aryPowerShell = new ArrayList();
            ArrayList aryIAsyncResult = new ArrayList();
            string strCmd = "";
            for (int i = 0; i <= strCmds.Length - 1; i++)
            {
                strCmd = strCmds[i];

                PowerShell objPowerShell = PowerShell.Create();
                objPowerShell.RunspacePool = objRunspacePool;
                objPowerShell.AddScript(strCmd);
                objPowerShell.AddCommand("Out-String");
                //PowerShellコマンド実行
                IAsyncResult objIAsyncResult = objPowerShell.BeginInvoke();

                aryPowerShell.Add(objPowerShell);
                aryIAsyncResult.Add(objIAsyncResult);
            }

            while ((aryPowerShell.Count > 0))
            {

                for (int i = 0; i <= aryPowerShell.Count - 1; i++)
                {
                    PowerShell objPowerShell = (PowerShell)aryPowerShell[i];
                    IAsyncResult objIAsyncResult = (IAsyncResult)aryIAsyncResult[i];

                    if ((objPowerShell != null))
                    {
                        if (objIAsyncResult.IsCompleted)
                        {
                            PSDataCollection<PSObject> objResultCollection = objPowerShell.EndInvoke(objIAsyncResult);

                            //PowerShellコマンドの実行結果を出力
                            foreach (PSObject objResult in objResultCollection)
                            {
                                Debug.WriteLine(objResult.ToString());
                            }

                            //PowerShellのエラーを出力
                            Collection<ErrorRecord> objErrors = objPowerShell.Streams.Error.ReadAll();
                            foreach (ErrorRecord objErrorRecord in objErrors)
                            {
                                Debug.WriteLine(objErrorRecord.Exception.Message);
                            }

                            objPowerShell.Dispose();
                            aryPowerShell.RemoveAt(i);
                            aryIAsyncResult.RemoveAt(i);
                            break;
                        }
                    }
                }
                System.Threading.Thread.Sleep(100);
            }
        }
    }

    static void RemotePipeline(string strServer, string strAccount, string strPassword, string strCmd, string[] strKeys,string[] strValues)
    {
        SecureString objSecureString = new SecureString();
        foreach (char c in strPassword.ToCharArray()) { objSecureString.AppendChar(c); }
        PSCredential objPSCredential = new PSCredential(strAccount, objSecureString);

        //WinRMを利用してリモートでPowerShellを実行
        Uri objUri = new Uri("http://" + strServer + ":5985/wsman");
        WSManConnectionInfo objWSManConnectionInfo = new WSManConnectionInfo(objUri, "http://schemas.microsoft.com/powershell/Microsoft.PowerShell", objPSCredential);
        using (Runspace objRunspace = RunspaceFactory.CreateRunspace(objWSManConnectionInfo))
        {
            objRunspace.Open();
            using (Pipeline objPipeline = objRunspace.CreatePipeline())
            {
                Command objCommand = new Command(strCmd);
                for (int i = 0; i <= strKeys.Length - 1; i++)
                {
                    CommandParameter objCommandParameter = new CommandParameter(strKeys[i], strValues[i]);
                    objCommand.Parameters.Add(objCommandParameter);
                }
                objPipeline.Commands.Add(objCommand);
                objPipeline.Commands.AddScript(strCmd);
                objPipeline.Commands.Add("Out-String");

                try
                {
                    //PowerShellコマンドの実行結果を出力
                    Collection<PSObject> objResultCollection = objPipeline.Invoke();
                    foreach (var objResult in objResultCollection)
                    {
                        Debug.WriteLine(objResult.ToString());
                    }
                }

                catch (Exception ex)
                {
                    //PowerShellのエラーを出力
                    Debug.WriteLine(ex.ToString());
                }
            }
        }
    }

    static void RemotePowershell(string strServer, string strAccount, string strPassword, string strCmd)
    {
        //パスワードを暗号化
        SecureString objSecureString = new SecureString();
        foreach (char c in strPassword.ToCharArray()) { objSecureString.AppendChar(c); }
        PSCredential objPSCredential = new PSCredential(strAccount, objSecureString);

        //WinRMを利用してリモートでPowerShellを実行
        Uri objUri = new Uri("http://" + strServer + ":5985/wsman");
        WSManConnectionInfo objWSManConnectionInfo = new WSManConnectionInfo(objUri, "http://schemas.microsoft.com/powershell/Microsoft.PowerShell", objPSCredential);
        using (Runspace objRunspace = RunspaceFactory.CreateRunspace(objWSManConnectionInfo))
        {
            objRunspace.Open();
            using (PowerShell objPowerShell = PowerShell.Create())
            {
                objPowerShell.Runspace = objRunspace;
                objPowerShell.AddScript(strCmd);

                //PowerShellコマンドの実行結果を出力
                Collection<PSObject> objResultCollection = objPowerShell.Invoke();
                foreach (var objResult in objResultCollection)
                {
                    //Debug.WriteLine(objResult.Properties["Name"].Value);
                    Debug.WriteLine(objResult.ToString());
                }

                //PowerShellのエラーを出力
                Collection<ErrorRecord> objErrors = objPowerShell.Streams.Error.ReadAll();
                foreach (ErrorRecord objErrorRecord in objErrors)
                {
                    Debug.WriteLine(objErrorRecord.Exception.Message);
                }
            }
        }
    }


    static void RunPowerShell(string strCmd)
    {
        //PowerShellのエラーを取得するためのオブジェクト
        IList objErrors = null;
        using (Runspace objRunspace = RunspaceFactory.CreateRunspace())
        {
            objRunspace.Open();
            RunspaceInvoke objRunspaceInvoke = new RunspaceInvoke(objRunspace);

            //PowerShellコマンドを実行
            Collection<PSObject> objResultCollection = objRunspaceInvoke.Invoke(strCmd, null, out objErrors);

            //PowerShellコマンドの実行結果を出力
            foreach (var objResult in objResultCollection)
            {
                Debug.WriteLine(objResult.ToString());
            }

            //PowerShellのエラーを出力
            foreach (PSObject objError in objErrors)
            {
                ErrorRecord objRecord = objError.BaseObject as ErrorRecord;
                Debug.WriteLine(objRecord.Exception.Message);
            }
        }
    }
}

